//+------------------------------------------------------------------+
//|                                                   MedStop_v1.mq4 |
//|                                                          Kalenzo |
//|                                          http://www.fxservice.eu |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "http://www.fxservice.eu"
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Magenta
#property indicator_color3 Lime
#property indicator_color4 Magenta

double hl[],med[],sl1[],sl2[],sl1l[],sl2l[];
extern int MPeriod = 20;
extern int CFrom = 2;
extern int SLDistance = 10;
extern double factor = 1.618;
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(6);
   SetIndexBuffer(0,sl1);
   SetIndexStyle(0,DRAW_ARROW,EMPTY,1);
   SetIndexBuffer(1,sl2);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,1);
   
   SetIndexBuffer(2,sl1l);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(3,sl2l);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1);
   
   SetIndexArrow(0,167);
   SetIndexArrow(1,167);
   
   SetIndexBuffer(4,hl);
   SetIndexBuffer(5,med);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
      int limit;
      int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
      limit=Bars-counted_bars;
 
      for(int i=0; i<limit; i++)
      {
         if(Open[i+1]<Close[i+1])
         {
            hl[i] = Open[i+1]-Low[i+1];      
         }
         else
         {
            hl[i] = High[i+1]-Open[i+1];  
         }  
      }
      
      double tmpAr[1];
      ArrayResize(tmpAr,MPeriod);
      
      int j = 0;
             
      if(MathMod(MPeriod,2)==0)
      {
         //PARZYSTE
         
         for(i=0; i<limit-MPeriod; i++)
         {
            ArrayInitialize(tmpAr,0);
            
            for(j=i; j<i+MPeriod; j++)
            {
               tmpAr[j-i] = hl[j];    
            }  
            
            ArraySort(tmpAr);
            med[i] = (tmpAr[MPeriod/2]+tmpAr[(MPeriod/2)+1])/2;
         }
         
      }
      else
      {
         //NIEPARZYSTE
         
         for(i=0; i<limit-MPeriod; i++)
         {
            ArrayInitialize(tmpAr,0);
            
            for(j=i; j<i+MPeriod; j++)
            {
               tmpAr[j-i] = hl[j];    
            }  
            
            ArraySort(tmpAr);
            med[i] = tmpAr[MPeriod/2];
         }   
      }   
      
      for(i=0; i<limit-MPeriod; i++)
      {
          
               sl1[i] = cf(CFrom,i,1)+(med[i]*factor)+(SLDistance*Point);
               sl2[i] = cf(CFrom,i,0)-(med[i]*factor)-(SLDistance*Point);
               
               sl1l[i] = sl1[i];
               sl2l[i] = sl2[i];
      }
 
   return(0);
  }
//+------------------------------------------------------------------+
double cf(int from,int index,int mode)
{
   //1 - Open; 2 - High/Low; 3 - Close

   if(from == 2)
   {  
      if(mode ==1)
      return(High[index]);
      else
      return(Low[index]);
   }
   else if(from == 1)
   return(Open[index]);
   else if(from == 3)
   return(Close[index]);
   else
   return(0);
}

